/**
 * Wolfram Cellular Automata
 * by Daniel Shiffman.  
 * 
 * Simple demonstration of a Wolfram 1-dimensional cellular automata
 * When the system reaches bottom of the window, it restarts with a new ruleset
 * Mouse click restarts as well. 
 */
 
CA ca;   // An instance object to describe the Wolfram basic Cellular Automata
int startUp = 0;

void setup() {
  size(640, 360, P2D);
  frameRate(30);
  background(0);
  int[] ruleset = {1,0,1,0,0,0,0,1};//{1,0,1,0,0,0,0,1};//{0,1,1,0,0,1,1,0};    // An initial rule system
  ca = new CA(ruleset);                 // Initialize CA
}

void draw() {
  ca.render();    // Draw the CA
  ca.generate();  // Generate the next level
  
  if (ca.finished() && (startUp == 0)) {   // If we're done, clear the screen, pick a new ruleset and restart
   fill(125);
   rect( 40, 5,100,20);
  for (int i=0;i<8;i++){
   print( ca.rules[i] );
  
   fill(255,255,0);
   text( ca.rules[i], 50 + i*10,20);
  }
   println();
   startUp = 1;
  }
}

void mousePressed() {
   for (int i=0;i<8;i++)
   print( ca.rules[i] );
   println();

    startUp = 0;
  background(0);
  ca.randomize();
  ca.restart();
}

void keyPressed(){
  
  if ( key == 'a')
  {
      startUp = 0;
     background(0);
    ca.randomize();
    ca.restart();
  }
  
  
}





